require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_ENDIAN_H_)) {
    eval 'sub _SYS_ENDIAN_H_ () {1;}' unless defined(&_SYS_ENDIAN_H_);
    require 'sys/cdefs.ph';
    require 'sys/_endian.ph';
    eval 'sub LITTLE_ENDIAN () { &_LITTLE_ENDIAN;}' unless defined(&LITTLE_ENDIAN);
    eval 'sub BIG_ENDIAN () { &_BIG_ENDIAN;}' unless defined(&BIG_ENDIAN);
    eval 'sub PDP_ENDIAN () { &_PDP_ENDIAN;}' unless defined(&PDP_ENDIAN);
    eval 'sub BYTE_ORDER () { &_BYTE_ORDER;}' unless defined(&BYTE_ORDER);
    eval 'sub htobe16 {
        my($x) = @_;
	    eval q( &__htobe16($x));
    }' unless defined(&htobe16);
    eval 'sub htobe32 {
        my($x) = @_;
	    eval q( &__htobe32($x));
    }' unless defined(&htobe32);
    eval 'sub htobe64 {
        my($x) = @_;
	    eval q( &__htobe64($x));
    }' unless defined(&htobe64);
    eval 'sub htole16 {
        my($x) = @_;
	    eval q( &__htole16($x));
    }' unless defined(&htole16);
    eval 'sub htole32 {
        my($x) = @_;
	    eval q( &__htole32($x));
    }' unless defined(&htole32);
    eval 'sub htole64 {
        my($x) = @_;
	    eval q( &__htole64($x));
    }' unless defined(&htole64);
    eval 'sub be16toh {
        my($x) = @_;
	    eval q( &__htobe16($x));
    }' unless defined(&be16toh);
    eval 'sub be32toh {
        my($x) = @_;
	    eval q( &__htobe32($x));
    }' unless defined(&be32toh);
    eval 'sub be64toh {
        my($x) = @_;
	    eval q( &__htobe64($x));
    }' unless defined(&be64toh);
    eval 'sub le16toh {
        my($x) = @_;
	    eval q( &__htole16($x));
    }' unless defined(&le16toh);
    eval 'sub le32toh {
        my($x) = @_;
	    eval q( &__htole32($x));
    }' unless defined(&le32toh);
    eval 'sub le64toh {
        my($x) = @_;
	    eval q( &__htole64($x));
    }' unless defined(&le64toh);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub swap16 {
	    my($x) = @_;
    	    eval q( &__swap16($x));
	}' unless defined(&swap16);
	eval 'sub swap32 {
	    my($x) = @_;
    	    eval q( &__swap32($x));
	}' unless defined(&swap32);
	eval 'sub swap64 {
	    my($x) = @_;
    	    eval q( &__swap64($x));
	}' unless defined(&swap64);
	eval 'sub swap16_multi {
	    my($v, $n) = @_;
    	    eval q( &do {  &__size_t  &__swap16_multi_n = ($n);  &__uint16_t * &__swap16_multi_v = ($v);  &while ( &__swap16_multi_n) { * &__swap16_multi_v =  &swap16(* &__swap16_multi_v);  &__swap16_multi_v++;  &__swap16_multi_n--; } }  &while (0));
	}' unless defined(&swap16_multi);
	eval 'sub betoh16 {
	    my($x) = @_;
    	    eval q( &__htobe16($x));
	}' unless defined(&betoh16);
	eval 'sub betoh32 {
	    my($x) = @_;
    	    eval q( &__htobe32($x));
	}' unless defined(&betoh32);
	eval 'sub betoh64 {
	    my($x) = @_;
    	    eval q( &__htobe64($x));
	}' unless defined(&betoh64);
	eval 'sub letoh16 {
	    my($x) = @_;
    	    eval q( &__htole16($x));
	}' unless defined(&letoh16);
	eval 'sub letoh32 {
	    my($x) = @_;
    	    eval q( &__htole32($x));
	}' unless defined(&letoh32);
	eval 'sub letoh64 {
	    my($x) = @_;
    	    eval q( &__htole64($x));
	}' unless defined(&letoh64);
	unless(defined(&htons)) {
	    eval 'sub htons {
	        my($x) = @_;
    		eval q( &__htobe16($x));
	    }' unless defined(&htons);
	    eval 'sub htonl {
	        my($x) = @_;
    		eval q( &__htobe32($x));
	    }' unless defined(&htonl);
	    eval 'sub ntohs {
	        my($x) = @_;
    		eval q( &__htobe16($x));
	    }' unless defined(&ntohs);
	    eval 'sub ntohl {
	        my($x) = @_;
    		eval q( &__htobe32($x));
	    }' unless defined(&ntohl);
	}
	eval 'sub NTOHL {
	    my($x) = @_;
    	    eval q(($x) =  &ntohl(( &u_int32_t)($x)));
	}' unless defined(&NTOHL);
	eval 'sub NTOHS {
	    my($x) = @_;
    	    eval q(($x) =  &ntohs(( &u_int16_t)($x)));
	}' unless defined(&NTOHS);
	eval 'sub HTONL {
	    my($x) = @_;
    	    eval q(($x) =  &htonl(( &u_int32_t)($x)));
	}' unless defined(&HTONL);
	eval 'sub HTONS {
	    my($x) = @_;
    	    eval q(($x) =  &htons(( &u_int16_t)($x)));
	}' unless defined(&HTONS);
    }
    if(defined(&_KERNEL)) {
	eval 'sub bemtoh16 () { &__bemtoh16;}' unless defined(&bemtoh16);
	eval 'sub bemtoh32 () { &__bemtoh32;}' unless defined(&bemtoh32);
	eval 'sub bemtoh64 () { &__bemtoh64;}' unless defined(&bemtoh64);
	eval 'sub htobem16 () { &__htobem16;}' unless defined(&htobem16);
	eval 'sub htobem32 () { &__htobem32;}' unless defined(&htobem32);
	eval 'sub htobem64 () { &__htobem64;}' unless defined(&htobem64);
	eval 'sub lemtoh16 () { &__lemtoh16;}' unless defined(&lemtoh16);
	eval 'sub lemtoh32 () { &__lemtoh32;}' unless defined(&lemtoh32);
	eval 'sub lemtoh64 () { &__lemtoh64;}' unless defined(&lemtoh64);
	eval 'sub htolem16 () { &__htolem16;}' unless defined(&htolem16);
	eval 'sub htolem32 () { &__htolem32;}' unless defined(&htolem32);
	eval 'sub htolem64 () { &__htolem64;}' unless defined(&htolem64);
    }
}
1;
