require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_VNODE_H_)) {
    eval 'sub _SYS_VNODE_H_ () {1;}' unless defined(&_SYS_VNODE_H_);
    require 'sys/buf.ph';
    require 'sys/types.ph';
    require 'sys/queue.ph';
    require 'sys/selinfo.ph';
    require 'sys/tree.ph';
    eval("sub VNON () { 0; }") unless defined(&VNON);
    eval("sub VREG () { 1; }") unless defined(&VREG);
    eval("sub VDIR () { 2; }") unless defined(&VDIR);
    eval("sub VBLK () { 3; }") unless defined(&VBLK);
    eval("sub VCHR () { 4; }") unless defined(&VCHR);
    eval("sub VLNK () { 5; }") unless defined(&VLNK);
    eval("sub VSOCK () { 6; }") unless defined(&VSOCK);
    eval("sub VFIFO () { 7; }") unless defined(&VFIFO);
    eval("sub VBAD () { 8; }") unless defined(&VBAD);
    eval 'sub VTYPE_NAMES () {"VNON", "VREG", "VDIR", "VBLK", "VCHR", "VLNK", "VSOCK", "VFIFO", "VBAD";}' unless defined(&VTYPE_NAMES);
    eval("sub VT_NON () { 0; }") unless defined(&VT_NON);
    eval("sub VT_UFS () { 1; }") unless defined(&VT_UFS);
    eval("sub VT_NFS () { 2; }") unless defined(&VT_NFS);
    eval("sub VT_MFS () { 3; }") unless defined(&VT_MFS);
    eval("sub VT_MSDOSFS () { 4; }") unless defined(&VT_MSDOSFS);
    eval("sub VT_PORTAL () { 5; }") unless defined(&VT_PORTAL);
    eval("sub VT_PROCFS () { 6; }") unless defined(&VT_PROCFS);
    eval("sub VT_AFS () { 7; }") unless defined(&VT_AFS);
    eval("sub VT_ISOFS () { 8; }") unless defined(&VT_ISOFS);
    eval("sub VT_ADOSFS () { 9; }") unless defined(&VT_ADOSFS);
    eval("sub VT_EXT2FS () { 10; }") unless defined(&VT_EXT2FS);
    eval("sub VT_VFS () { 11; }") unless defined(&VT_VFS);
    eval("sub VT_NTFS () { 12; }") unless defined(&VT_NTFS);
    eval("sub VT_UDF () { 13; }") unless defined(&VT_UDF);
    eval("sub VT_FUSEFS () { 14; }") unless defined(&VT_FUSEFS);
    eval("sub VT_TMPFS () { 15; }") unless defined(&VT_TMPFS);
    eval 'sub VTAG_NAMES () {"NON", "UFS", "NFS", "MFS", "MSDOSFS", "unused", "unused", "unused", "ISOFS", "unused", "EXT2FS", "VFS", "NTFS", "UDF", "FUSEFS", "TMPFS";}' unless defined(&VTAG_NAMES);
    eval 'sub v_mountedhere () { ($v_un->{vu_mountedhere});}' unless defined(&v_mountedhere);
    eval 'sub v_socket () { ($v_un->{vu_socket});}' unless defined(&v_socket);
    eval 'sub v_specinfo () { ($v_un->{vu_specinfo});}' unless defined(&v_specinfo);
    eval 'sub v_fifoinfo () { ($v_un->{vu_fifoinfo});}' unless defined(&v_fifoinfo);
    eval 'sub VROOT () {0x1;}' unless defined(&VROOT);
    eval 'sub VTEXT () {0x2;}' unless defined(&VTEXT);
    eval 'sub VSYSTEM () {0x4;}' unless defined(&VSYSTEM);
    eval 'sub VISTTY () {0x8;}' unless defined(&VISTTY);
    eval 'sub VXLOCK () {0x100;}' unless defined(&VXLOCK);
    eval 'sub VXWANT () {0x200;}' unless defined(&VXWANT);
    eval 'sub VCLONED () {0x400;}' unless defined(&VCLONED);
    eval 'sub VALIASED () {0x800;}' unless defined(&VALIASED);
    eval 'sub VLARVAL () {0x1000;}' unless defined(&VLARVAL);
    eval 'sub VLOCKSWORK () {0x4000;}' unless defined(&VLOCKSWORK);
    eval 'sub VCLONE () {0x8000;}' unless defined(&VCLONE);
    eval 'sub VBITS () {"\\010\\001ROOT\\002TEXT\\003SYSTEM\\004ISTTY\\010XLOCK" "\\011XWANT\\013ALIASED\\014LARVAL\\016LOCKSWORK\\017CLONE";}' unless defined(&VBITS);
    eval 'sub VBIOWAIT () {0x1;}' unless defined(&VBIOWAIT);
    eval 'sub VBIOONSYNCLIST () {0x2;}' unless defined(&VBIOONSYNCLIST);
    eval 'sub VBIOONFREELIST () {0x4;}' unless defined(&VBIOONFREELIST);
    eval 'sub VA_UTIMES_NULL () {0x1;}' unless defined(&VA_UTIMES_NULL);
    eval 'sub VA_EXCLUSIVE () {0x2;}' unless defined(&VA_EXCLUSIVE);
    eval 'sub VA_UTIMES_CHANGE () {0x4;}' unless defined(&VA_UTIMES_CHANGE);
    eval 'sub IO_UNIT () {0x1;}' unless defined(&IO_UNIT);
    eval 'sub IO_APPEND () {0x2;}' unless defined(&IO_APPEND);
    eval 'sub IO_SYNC () {0x4;}' unless defined(&IO_SYNC);
    eval 'sub IO_NODELOCKED () {0x8;}' unless defined(&IO_NODELOCKED);
    eval 'sub IO_NDELAY () {0x10;}' unless defined(&IO_NDELAY);
    eval 'sub IO_NOLIMIT () {0x20;}' unless defined(&IO_NOLIMIT);
    eval 'sub IO_NOCACHE () {0x40;}' unless defined(&IO_NOCACHE);
    eval 'sub VSUID () {04000;}' unless defined(&VSUID);
    eval 'sub VSGID () {02000;}' unless defined(&VSGID);
    eval 'sub VSVTX () {01000;}' unless defined(&VSVTX);
    eval 'sub VREAD () {00400;}' unless defined(&VREAD);
    eval 'sub VWRITE () {00200;}' unless defined(&VWRITE);
    eval 'sub VEXEC () {00100;}' unless defined(&VEXEC);
    eval 'sub VNOVAL () {(-1);}' unless defined(&VNOVAL);
    if(defined(&_KERNEL)) {
	eval 'sub IFTOVT {
	    my($mode) = @_;
    	    eval q(( $iftovt_tab[(($mode) &  &S_IFMT) >> 12]));
	}' unless defined(&IFTOVT);
	eval 'sub VTTOIF {
	    my($indx) = @_;
    	    eval q(( $vttoif_tab[($indx)]));
	}' unless defined(&VTTOIF);
	eval 'sub MAKEIMODE {
	    my($indx, $mode) = @_;
    	    eval q(( &VTTOIF($indx) | ($mode)));
	}' unless defined(&MAKEIMODE);
	eval 'sub SKIPSYSTEM () {0x1;}' unless defined(&SKIPSYSTEM);
	eval 'sub FORCECLOSE () {0x2;}' unless defined(&FORCECLOSE);
	eval 'sub WRITECLOSE () {0x4;}' unless defined(&WRITECLOSE);
	eval 'sub DOCLOSE () {0x8;}' unless defined(&DOCLOSE);
	eval 'sub V_SAVE () {0x1;}' unless defined(&V_SAVE);
	eval 'sub V_SAVEMETA () {0x2;}' unless defined(&V_SAVEMETA);
	eval 'sub REVOKEALL () {0x1;}' unless defined(&REVOKEALL);
	eval 'sub VATTR_NULL {
	    my($vap) = @_;
    	    eval q( &vattr_null($vap));
	}' unless defined(&VATTR_NULL);
	eval 'sub NULLVP () {( &NULL);}' unless defined(&NULLVP);
	eval 'sub VN_KNOTE {
	    my($vp, $b) = @_;
    	    eval q( &KNOTE( ($vp->{v_selectinfo}->{si_note}), ($b)));
	}' unless defined(&VN_KNOTE);
	eval 'sub GETCWD_CHECK_ACCESS () {0x1;}' unless defined(&GETCWD_CHECK_ACCESS);
    }
}
1;
